extern static unsigned long int localtime ( unsigned long int input);
/****************  STATE TO ASCII FUNCTION ****************************************/
extern static char * state_to_ascii(unsigned long int state, chr *scr_state);
extern unsigned long int ascii_to_state (char * scr_state);
extern char * event_to_ascii(XEvent *ev, char * line);
XEvent * ascii_to_event (
    char * line,
    XEvent *ev
)
{

   int scr_x, scr_y, scr_xroot, scr_yroot;
   char scr_type[2];
   char scr_state[13];
   unsigned long int scr_time;
   int scr_win, scr_subw;
   char scr_spec_str [40];
   int error = 0;

   if (10 != sscanf(line,"%s %s %s %x %x %4d %4d %4d %4d %lu",
      scr_type, scr_spec_str, scr_state, &scr_win, &scr_subw,
      &scr_x,&scr_y,&scr_xroot, &scr_yroot, &scr_time))
               error = 1;

  if (error) return 0;

  ev->xany.display = dpy;

  switch(scr_type[0])
  {
    case 'B' :  case 'b' :  
      switch (scr_type[1])
      {
        case 'P' :  case 'p' : ev->type = ButtonPress;   break;
        case 'R' :  case 'r' : ev->type = ButtonRelease; break;
        default :   error = 1;   break;
      }
     if (error) return 0;
     ev->xbutton.time = scr_time;
     ev->xbutton.window = scr_win;
     ev->xbutton.subwindow = scr_subw;
     ev->xbutton.x = scr_x;
     ev->xbutton.y = scr_y;
     ev->xbutton.x_root = scr_xroot;
     ev->xbutton.y_root = scr_yroot;
     ev->xbutton.button = atoi (scr_spec_str);
     ev->xbutton.state  = ascii_to_state ( scr_state );
     break;


    case 'K' :  case 'k' : 
      switch (scr_type[1])
      {
        case 'P' :  case 'p' : ev->type = KeyPress;   break;
        case 'R' :  case 'r' : ev->type = KeyRelease; break;
        default :   error = 1;   break;
      }
     if (error) return 0;
     ev->xkey.time = scr_time;
     ev->xkey.window = scr_win;
     ev->xkey.subwindow = scr_subw;
     ev->xkey.x = scr_x;
     ev->xkey.y = scr_y;
     ev->xkey.x_root = scr_xroot;
     ev->xkey.y_root = scr_yroot;
     if (dpy) 
     { 
        ev->xkey.keycode= XKeysymToKeycode(dpy, XStringToKeysym (scr_spec_str));
     }
     else
     {
        ev->xkey.keycode= 0;
     }
     ev->xkey.state  = ascii_to_state ( scr_state );
     break;

    case 'M' :  case 'm' :
      switch (scr_type[1])
      {
        case 'N' :  case 'n' : ev->type = MotionNotify;  break;
        default :   error = 1;   break;
      }
     if (error) return 0;
     ev->xmotion.time = scr_time;
     ev->xmotion.window = scr_win;
     ev->xmotion.subwindow = scr_subw;
     ev->xmotion.x = scr_x;
     ev->xmotion.y = scr_y;
     ev->xmotion.x_root = scr_xroot;
     ev->xmotion.y_root = scr_yroot;
     ev->xmotion.is_hint = False;
     if  ((scr_spec_str[0] == 'H') || (scr_spec_str[0] == 'h'))
     {
       ev->xmotion.is_hint = True;
     }
     ev->xmotion.state  = ascii_to_state ( scr_state );
     break;
  }

  return ev;
      
} 
